/**
 * Created by Zack on 2017/11/29.
 */
var wb = wb || {};

wb.reLoadConfig = {
    CONFIG_KEY: {
        width: "width",
        height: "height",
        engineDir: "engineDir",
        modules: "modules",
        debugMode: "debugMode",
        showFPS: "showFPS",
        frameRate: "frameRate",
        id: "id",
        renderMode: "renderMode",
        jsList: "jsList"
    },
    currentSceneStr: null,
    config: null,
    run: function () {
        wb.currentSceneStr = wb.GameHelper.getCurrenetResStr();
        cc.log("getCurrentSceneStrA " + wb.currentSceneStr);

        this._prepare();
    },
    _prepare: function () {
        this._loadConfig();
        // Load game scripts
        var jsList = this.config[this.CONFIG_KEY.jsList];

        for (var i = 0; i < jsList.length; i++) {
            jsList[i] = wb.currentSceneStr + "/" + jsList[i];
            cc.log("newjsList " + jsList[i]);
        }

        if (jsList) {
            cc.loader.loadJsWithImg(jsList, function (err) {
                if (err) throw new Error(err);
            });
        }

        // require("script/jsb.js");
        cc._renderType = cc.game.RENDER_TYPE_OPENGL;
        cc._initDebugSetting(this.config[cc.game.CONFIG_KEY.debugMode]);
        cc._engineLoaded = true;
        cc.log("reLoadConfig1  " + cc.ENGINE_VERSION);
    },
    _loadConfig: function () {

        try {
            var txt = jsb.fileUtils.getStringFromFile(wb.currentSceneStr + "/project.json");
            var data = JSON.parse(txt);
            this._initConfig(data || {});
        } catch (e) {
            console.log("Failed to read or parse project.json");
            this._initConfig({});
        }

    },

    _initConfig: function (config) {
        var CONFIG_KEY = this.CONFIG_KEY;
        // Configs adjustment
        config[CONFIG_KEY.showFPS] = typeof config[CONFIG_KEY.showFPS] === 'undefined' ? true : config[CONFIG_KEY.showFPS];
        config[CONFIG_KEY.engineDir] = config[CONFIG_KEY.engineDir] || "frameworks/cocos2d-html5";
        if (config[CONFIG_KEY.debugMode] == null)
            config[CONFIG_KEY.debugMode] = 0;
        config[CONFIG_KEY.frameRate] = config[CONFIG_KEY.frameRate] || 60;
        if (config[CONFIG_KEY.renderMode] == null)
            config[CONFIG_KEY.renderMode] = 0;

        this.config = config;

        cc.director.setDisplayStats(this.config[CONFIG_KEY.showFPS]);
        cc.director.setAnimationInterval(1.0 / this.config[CONFIG_KEY.frameRate]);
    }
}

wb.reLoadConfig.run();
