/**
 * Created by Zack on 2018/1/9.
 */

var wb = wb || {}

wb.os = function () {
    return cc.sys.os;
};

wb.isNative = function () {
    if (wb.isWX()) return false;
    return cc.sys.isNative;
};
wb.isWX = function () {
    return window.wx ? true : false;
};
wb.isMobile = function () {
    return cc.sys.isMobile;
};

wb.isMobileBrowser = function () {
    return cc.sys.platform == cc.sys.MOBILE_BROWSER;
};

wb.isDesktopBrowser = function () {
    return cc.sys.platform == cc.sys.DESKTOP_BROWSER;
};

wb.isBrowser = function () {
    return wb.isDesktopBrowser() || wb.isMobileBrowser();
};

wb.browserType = function () {
    return cc.sys.browserType;
};

wb.isInteger = function (obj) {
    return typeof obj === "number" && obj % 1 === 0
};

wb.isFloat = function (obj) {
    return typeof obj === "number" && obj % 1 != 0
};

wb.isBoolean = function (obj) {
    return typeof obj === "boolean";
};

wb.isString = function (obj) {
    return typeof obj === "string";
};

///////////////////////////////////////////////////

wb.uniqueObj = function (objOrigin, objNew) {
    for (var k in objOrigin) {
        if (objOrigin.hasOwnProperty(k)) {
            if (objNew[k] == undefined) {
                objNew[k] = objOrigin[k];
            }
        }
    }
    return objNew;
};

wb.uniqueArray = function (array) {
    var result = [];
    for (var i = 0; i < array.length; i++) {
        if (result.indexOf(array[i]) == -1) result.push(array[i]);
    }
    return result;
};

wb.concatArray = function (array) {
    var arr, i;
    for (i = 1; i < arguments.length; i++) {
        arr = arguments[i];
        Array.prototype.push.apply(array, arr);
    }
};

wb.spliceArray = function (array, index, num) {
    var i, len;
    for (i = index + num, len = array.length; i < len; i++) {
        array[i - num] = array[i];
    }
    array.length = len - num;
};

wb.copyArray = function (array) {
    var arrTemp = []
    for (var i = 0; i < array.length; i++) {
        arrTemp.push(array[i])
    }
    return arrTemp
};

wb.isInArray = function (array, item) {
    for (var i = 0; i < array.length; i++) {
        if (array[i] == item) return true;
    }
    return false
};

wb.getRandomInArray = function (array) {
    if (array == null) return null;
    var i = wb.randNum(0, array.length);
    return array[i];
};

wb.shuffleArray = function (array, len) {
    if (len === undefined || len <= 0 || len > array.length) len = array.length;
    for (var i = len - 1; i >= 0; i--) {
        var j = 0 | (cc.rand() % (i + 1));
        var v = array[i];
        array[i] = array[j];
        array[j] = v;
    }
};

wb.getLastInArray = function (array) {
    if (!array || array.length <= 0) return null;
    return array[array.length - 1];
};

wb.getFirstInArray = function (array) {
    if (!array || array.length <= 0) return null;
    return array[0];
};

wb.getItemInArrayByFunc = function (array, func) {
    if (!array || !func) return null;
    for (var i = 0; i < array.length; i++) {
        if (func(array[i])) return array[i];
    }
    return null;
};

wb.removeItemInArray = function (array, item) {
    var index = array.indexOf(item);
    if (index <= -1) return false;
    array.splice(index, 1);
    return true;
};

////////////////////////////////////////////////

wb.randNum = function (min, max) {
    return Math.floor(Math.random() * (max - min + 1) + min);
};

wb.randBool = function () {
    if (wb.randNum(1, 10) <= 5) return true;
    return false;
};
////////////////////////////////////////////////

wb.boolToStr = function (flag) {
    if (flag) return "true";
    return "false"
};

wb.strToBool = function (str) {
    if ("true" == str || str === true) return true;
    return false;
};

////////////////////////////////////////////////

wb.getWinSize = function () {
    return cc.director.getWinSize();
};
wb.getItem = function (key, value) {
    var tag = cc.sys.localStorage.getItem(key);
    if (tag == undefined || tag == null || tag === "") return value;
    return tag;
};

wb.setItem = function (key, value) {
    cc.sys.localStorage.setItem(key, value);
};
//////////////////////////////////////////////////

wb.FW = function (rootNode, name, func, data) {
    if (func) return wb.FWC(rootNode, name, func, data);
    return ccui.helper.seekWidgetByName(rootNode, name);
};

wb.FWC = function (rootNode, name, func, data) {
    var node = wb.FW(rootNode, name);
    if (!node) return null;
    if (node instanceof ccui.Button) node.setPressedActionEnabled(true);
    node.addClickEventListener(func);
    node.data = data;
    return node;
};

//////////////////////////////////////////////////
wb.closeAllAd = function () {
    for (var i = 0; i < wb.adPosition.length; i++) {
        wb.ADManager.closeAd(wb.adPosition[i]);
    }
};

wb.popAction = function (time) {
    if (!time) time = 0;
    return cc.sequence(cc.delayTime(time), cc.scaleTo(0.2, 1.1), cc.scaleTo(0.2, 1.0));
};

wb.popUI = function (node, time) {
    if (!node) return false;
    node.setScale(0);
    node.runAction(wb.popAction(time));
};

wb.btnClickAction = function () {
    return cc.sequence(cc.scaleTo(0.05, 1.1), cc.scaleTo(0.05, 1.0));
};

wb.scaleToSize = function (node, size) {
    var nodeSize = node.getContentSize();
    node.setScaleX(size.width / nodeSize.width);
    node.setScaleY(size.height / nodeSize.height);
};

wb.getCenterP = function () {
    var size = cc.director.getWinSize();
    return cc.p(size.width / 2, size.height / 2);
};

wb.getNodeSubP = function (node1, node2) {
    if (!node1 || !node2) return null;
    return cc.p(node1.getPositionX() - node2.getPositionX(), node1.getPositionY() - node2.getPositionY());
};

wb.getNodeCenterP = function (node) {
    if (!node) return null;
    var size = node.getContentSize();
    return cc.p(size.width / 2, size.height / 2);
};
///////////////////////////////////////////////////////
wb.getCoin = function () {
    return wb.getCoinDefault(0);
};

wb.getCoinDefault = function (val) {
    return parseInt(wb.GCUserDefault.getItem("coins", val));
};

wb.setCoin = function (val) {
    wb.GCUserDefault.setItem("coins", val);
    wb.GCUserDefault.save();
};

wb.addCoin = function (val) {
    var c_coin = wb.getCoin();
    if (c_coin <= 0 && val < 0)
        return false;
    wb.setCoin(c_coin + val > 0 ? (c_coin + val) : 0);
    wb.GCUserDefault.save();
    return true;
};

wb.getMusicEnable = function () {
    return parseInt(wb.GCUserDefault.getItem("music", 1));
};

wb.setMusicEnable = function (val) {
    wb.GCUserDefault.setItem("music", val ? 1 : 0);
    wb.GCUserDefault.save();
};

wb.getSoundEnable = function () {
    return parseInt(wb.GCUserDefault.getItem("sound", 1));
};

wb.setSoundEnable = function (val) {
    wb.GCUserDefault.setItem("sound", val ? 1 : 0);
    wb.GCUserDefault.save();
};

wb.getADEnabled = function () {
    return wb.GCUserDefault.getBoolForKey("ADEnabled", true);
};

wb.setADEnabled = function (enabled) {
    wb.GCUserDefault.setBoolForKey("ADEnabled", enabled);
    wb.GCUserDefault.save();
};

wb.playEffect = function (char, bool) {
    if (wb.getSoundEnable()) cc.audioEngine.playEffect((char), bool);
};

wb.playMusic = function (char, bool) {
    cc.audioEngine.stopMusic();
    if (wb.getMusicEnable()) cc.audioEngine.playMusic((char), bool);
};

/////////////////////////////////////////////////////////////

wb.addNodeToScene = function (node, zorder) {
    if (!node) return;
    if (!zorder) zorder = 999999;
    cc.director.getRunningScene().addChild(node, zorder);
};

wb.subScore = function (n) {
    var num = parseFloat(n);
    if (num > 1000) {
        num = num / 1000;
        return "" + num.toFixed(1) + "k";
    } else if (num > 10000) {
        num = num / 10000;
        return "" + num.toFixed(1) + "w";
    }
    return "" + n;
};

wb.stringify = function (dataObject) {
    return JSON.stringify(dataObject)
};

wb.parse = function (jsonstr) {
    return JSON.parse(jsonstr);
};

wb.angleNormal = function (angle) {
    var newAngle = angle - parseInt(angle / 360) * 360;
    if (newAngle < 0) newAngle = newAngle + 360;
    return newAngle;
};

////////////////////////////////////////////////////////////////
wb.base64 = {

    // private property
    _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    // public method for encoding
    encode: function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;
        input = this._utf8_encode(input);
        while (i < input.length) {
            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);
            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;
            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }
            output = output +
                this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
                this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);
        }
        return output;
    },

    // public method for decoding
    decode: function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
        while (i < input.length) {
            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));
            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;
            output = output + String.fromCharCode(chr1);
            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }
        }
        output = this._utf8_decode(output);
        return output;
    },

    // private method for UTF-8 encoding
    _utf8_encode: function (string) {
        string = string.replace(/\r\n/g, "\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            } else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            } else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }
        return utftext;
    },

    // private method for UTF-8 decoding
    _utf8_decode: function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;
        while (i < utftext.length) {
            c = utftext.charCodeAt(i);
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            } else if ((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            } else {
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
        }
        return string;
    }
};
wb.Base64 = wb.base64;

wb.TOOLIDS =
    {
        ID_Coin: 1,
        ID_Tool1: 2,
        ID_Tool2: 3,
    };

wb.tools =
    {
        data:
            {},
        addTool: function (id, num) {
            if (wb.TOOLIDS.ID_Coin === id) {
                return wb.addCoin(num);
            }
            if (this.data[id + ""]) {
                this.data[id + ""] += num;
            }
            else {
                this.data[id + ""] = num;
            }
            this.saveTools();
            return true;
        },
        useTool: function (id, num) {
            if (wb.TOOLIDS.ID_Coin === id) {
                return wb.addCoin(-num);
            }
            if (this.data[id + ""]) {
                this.data[id + ""] -= num;
                if (this.data[id + ""] <= 0) {
                    this.data[id + ""] = 0;
                }
            }
            else {
                this.data[id + ""] = 0;
                this.saveTools();
                return false;
            }
            this.saveTools();
            return true;
        },
        loadTools: function () {
            var str = wb.GCUserDefault.getItem("wb_tool_list", "");
            this.parseJsonData(str);
        },
        saveTools: function () {
            wb.GCUserDefault.setItem("wb_tool_list", this.obj2Str());
            wb.GCUserDefault.save();
        },
        str2Array: function (data) {
            var ret = [];
            if (data.length > 2) {
                ret = JSON.parse(data);
            }
            return ret;
        },
        parseJsonData: function (data) {
            if (data && data.length > 0) {
                var obj = this.str2Array(data);
                this.data = wb.uniqueObj(obj, {});
            }
        },
        obj2Str: function () {
            var str = JSON.stringify(this.data);
            return JSON.stringify(this.data);
        }
    };

