/**
 * Created by skai1 on 2018/5/8.
 */

var wb = wb || {};
wb.netTime = 0;
//wb.OnLineTime = 0;
//wb.OnLineUpdated = 0;
/**
 * @method 启动定时器
 */
wb.startTimeThread = function()
{
    if(wb.netTime !== 0)
    {
        wb.netTime +=1;
    }
    //if(wb.OnLineUpdated === 1)
    //{
    //    wb.OnLineTime ++;
    //}
    setTimeout("wb.startTimeThread()",1000);
    //setTimeout(wb.startTimeThread,1000); //这样也可以
};

/**
 * @method 获取网络时间
 *@return {int} 秒级时间戳
 */
wb.getNetTime = function()
{
  return wb.netTime;
};
/**
 * @method 获取时间
 *@return {int} 秒级时间戳  优先返回网络时间
 */
wb.getTime = function()
{
    return wb.netTime >0 ? wb.netTime: wb.getLocalTime();
};
/**
 * @method 获取时间
 *@return {int} 秒级时间戳  本机时间
 */
wb.getLocalTime = function()
{
    return  parseInt(new Date().getTime() / 1000 );
};
/**
 * @method 获取日期
 * @param {int} year  年    2018
 * @param {int} month 月    0-11
 * @param {int} day  日      1-31
 *@return {str}   日期  如 20180512
 */
wb.getDateA = function(year,month,day)
{
    var ret = "";
    ret += year;
    if(month+1 <10)
    {
        ret +="0";
    }
    ret += (month+1);
    if(day <10)
    {
        ret +="0";
    }
    ret += day;
    return ret;
};

/**
 * @method 获取日期
 *@return {str}   本机日期  如 20180512
 */
wb.getDate = function()
{
    var ret = "";
    var dat = new Date(wb.getLocalTime() * 1000);
    ret += dat.getFullYear();
    if(dat.getMonth()+1 <10)
    {
        ret +="0";
    }
    ret += (dat.getMonth()+1);
    if(dat.getDate() <10)
    {
        ret +="0";
    }
    ret += dat.getDate();
    return ret;
};
/**
 * @method 获取日期
 *@return {str}   网络时间日期  如 20180512  网络时间没有取到时会返回 ""
 */
wb.getNetDate = function()
{
    var ret = "";
    if(wb.netTime >0)
    {
        var dat = new Date(wb.netTime * 1000);
        ret += dat.getFullYear();
        if(dat.getMonth()+1 <10)
        {
            ret +="0";
        }
        ret += (dat.getMonth()+1);
        if(dat.getDate() <10)
        {
            ret +="0";
        }
        ret += dat.getDate();
    }
    return ret;
},



GETUSERURL = "https://api.vzhifu.net/some/getUserInfo";             //获取用户
UPDATEUSERURL = "https://api.vzhifu.net/some/updateUserInfo";       //更改用户信息
GIFTURL ="https://api.vzhifu.net/some/giftconfig";                  //获取礼包配置
GETTIMEURL ="https://api.vzhifu.net/myServlet";                     //获取网络时间

/**
 * @method    post请求
 * @param {str} url 链接地址
 * @param {str} params post的数据
 * @param {function} callback 回调
 */
wb.HttpPost =function(url,params,callback){
    var xhr = cc.loader.getXMLHttpRequest();
    xhr.open("POST", url);
    xhr.setRequestHeader("Content-Type","application/x-www-form-urlencoded;charset=UTF-8");
    xhr["onloadend"] = function(){
        var sc = -1;
        var rc =0;
        var json= "";
        if (xhr.readyState == 4 && (xhr.status >= 200 && xhr.status <= 207)) {
            sc = 0;
        }
        if(xhr.responseText.length >0)
        {
            json = JSON.parse(xhr.responseText);
            rc = parseInt(json["code"]);
        }
        callback(sc, rc, json);
    };
    xhr.send(params);
};
/**
 * @method 矫正网络时间
 */
wb.fixNetTime =function()
{
    var xhr = cc.loader.getXMLHttpRequest();
    xhr.open("GET", GETTIMEURL);
    xhr.onreadystatechange = function () {
        if (xhr.readyState == 4 && (xhr.status >= 200 && xhr.status <= 207)) {
            var response = xhr.responseText;
            if(response && response.length >1)
            {
                wb.netTime = parseInt(new Date(response).getTime()/1000 );
                wb.HJCore.getNetTimeCallBack();
            }
        }
    };
    xhr.send();
};
/**
 * @class 合集基础类
 */
wb.HJCore =
{
    inited:false,
    sameDay:true,
    sameDayNet:0,           //0 默认值       1是同一天           -1不是同一天
    /**
     * @method 合集基础类 初始化， main.js里面初始化
     */
    init:function()
    {
        if(this.inited) return;
        wb.OnLineTime = 0;
        //wb.OnLineUpdated = 0;
        this.inited = true;
        this.sameDay = true;
        this.sameDayNet = 0;
        var prevday = parseInt(wb.GCUserDefault.getItem("hjprevday", 0));
        var c_day = wb.getDate();
        if(c_day - prevday >0)
        {
            this.sameDay = false;
            //wb.GCUserDefault.setItem("hjonlinetime", 0);
            wb.GCUserDefault.setItem("hjprevday", c_day);
            wb.GCUserDefault.save();
        }
        else
        {
            //wb.OnLineTime = parseInt(wb.GCUserDefault.getItem("hjonlinetime", 0));
        }
        wb.WBUser.init();
        wb.tools.loadTools();
        wb.HjTaskManager.init();
        wb.HjPopupManager.init();
        wb.HjPushManager.init();
        wb.HjShareManager.init();
        wb.HjOnlineManager.init();
        wb.PayManager.init();
        wb.startTimeThread();
        wb.fixNetTime();
        wb.WBUser.submitInfo();  //每次启动游戏提交一次用户数据
    },

    /**
     * @method 程序进入后台
     */
    onPause:function()
    {
        wb.HjPushManager.onPause();
        //if(wb.OnLineUpdated === 1)
        //{
        //    wb.OnLineUpdated = -1;
        //}
    },
    /**
     * @method 程序从后台进入前台
     */
    onResume:function()
    {
        wb.HjPushManager.onResume();
        //if(wb.OnLineUpdated === -1)
        //{
        //    wb.OnLineUpdated = 1;
        //}
    },
    /**
     * @method 进入游戏界面   主要用于在线时长的统计
     */
    onEnterGame:function()
    {
        wb.OnLineUpdated = 1;
        wb.HjOnlineManager.onEnterGame();
    },
    /**
     * @method 退出游戏界面   保存当前在线时长
     */
    onOutGame:function()
    {
        wb.OnLineUpdated = 0;
        //wb.GCUserDefault.setItem("hjonlinetime",  wb.OnLineTime);
        //wb.GCUserDefault.save();
        wb.HjOnlineManager.onOutGame();
    },
    /**
     * @method 是否是同一天  本地时间
     * @return {bool}
     */
    isSameDay:function()
    {
        return this.sameDay;
    },
    /**
     * @method 是否是同一天  网络时间
     * @return {int}   //0 没有网络时间     1是同一天           -1不是同一天
     */
    isSameDayNet:function()
    {
        return this.sameDayNet;
    },
    /**
     * @method 取到网络时间之后的回调
     */
    getNetTimeCallBack:function()
    {
        var prevnettime = parseInt(wb.GCUserDefault.getItem("hjprevnetday", 0));
        var c_day = wb.getNetDate();
        if(c_day - prevnettime >0)
        {
            this.sameDayNet = -1;
            wb.GCUserDefault.setItem("hjprevnetday", c_day);
        }else
        {
            this.sameDayNet = 1;
        }
    }
};