/**
 * Created by skai1 on 2018/5/14.
 */

wb.HjOnlineCfg = wb.BaseCfgItem.extend({
    data:{
        times:[],                   //间隔时间
        boundsIds:[],               //奖励内容
        boundsNums:[],              //奖励数量
    },
    ctor:function()
    {
    },
    parseData:function(data)
    {
        if(data && data.length>1)
        {
            this.data.times = JSON.parse(data[0]);
            this.data.boundsIds = JSON.parse(data[1]);
            this.data.boundsNums = JSON.parse(data[2]);
        }
    },
});


wb.HjOnlineManager ={

    onlineCfg:null,         //在线时长配置
    countdownTime:0,        //倒计时
    countdownIng:false,     //正在执行倒计时
    currentLv:0,            //当前等级
    init:function()
    {
        this.onlineCfg = null;
        wb.CSVParse.parseConfig(wb.res.online_cfg_csv,function(data)
        {
            if(data && data.length > 2 )
            {
                if(data[2].length >1)
                {
                    this.onlineCfg = new wb.HjOnlineCfg();
                    this.onlineCfg.parseData(data[2]);
                    this.fixCountdownTime();
                    this.startCountdown();
                }
            }
        }.bind(this));

        if(wb.HJCore.isSameDay())
        {
            this.currentLv = parseInt(wb.GCUserDefault.getItem("hjOnlineLv", 0));
            this.countdownTime = parseInt(wb.GCUserDefault.getItem("hjCountdownTime", 0));
        }
        else
        {
            wb.GCUserDefault.setItem("hjOnlineLv", 0);
            wb.GCUserDefault.save();
            this.countdownTime = 0;
        }
    },
    /**
     * @method 是否还有奖励可以领取
     * @return {bool}
     */
    haveExtraBounds:function()
    {
        if(this.onlineCfg && this.currentLv <= this.onlineCfg.data.times.length -1)
        {
            return true;
        }
        return false;
    },
    /**
     * @method 修正倒计时
     */
    fixCountdownTime:function()
    {
        if(this.haveExtraBounds())
        {
            this.countdownTime = this.onlineCfg.data.times[this.currentLv];
            if(this.countdownTime <0) this.countdownTime = 0;
        }
        else
        {
            this.countdownTime = 0;
        }
    },
    /**
     * @method 是否可以领取奖励
     * @return {int}   -1 已领取全部      0时间未到      1可领取
     */
    getBoundsEnable:function()
    {
        if(this.haveExtraBounds())
        {
            if(this.countdownTime === 0)
            {
                return 1;
            }
            return 0;
        }
        return -1;
    },
    /**
     * @method 领取完奖励之后要调用一下
     */
    getBounds:function()
    {
        this.currentLv ++;
        this.fixCountdownTime();
        this.startCountdown();
        wb.GCUserDefault.setItem("hjCountdownTime", this.countdownTime);
        wb.GCUserDefault.setItem("hjOnlineLv", this.currentLv );
        wb.GCUserDefault.save();
    },
    /**
     * @method 获取奖励内容
     * @return {array}   数组类型
     */
    getBoundsIds:function()
    {
        if(this.haveExtraBounds())
        {
            return this.onlineCfg.data.boundsIds[this.currentLv];
        }
        return [];
    },
    /**
     * @method 获取奖励数量
     * @return {array}   数组类型
     */
    getBoundsNums:function()
    {
        if(this.haveExtraBounds())
        {
            return this.onlineCfg.data.boundsNums[this.currentLv];
        }
        return [];
    },
    /**
     * @method 倒计时
     */
    startCountdown:function()
    {
        if(this.haveExtraBounds() && this.countdownTime >0)
        {
            if(this.countdownIng)
            {
                this.countdownTime  --;
            }
            if(this.countdownTime >0)
            {
                setTimeout("wb.HjOnlineManager .startCountdown()", 1000);
            }
        }
    },
    /**
     * @method 程序进入后台
     */
    onPause:function()
    {
        this.countdownIng = false;
    },
    /**
     * @method 程序从后台进入前台
     */
    onResume:function()
    {
        if(!this.countdownIng)
        {
            this.countdownIng = true;
        }
    },
    /**
     * @method 进入游戏界面   主要用于在线时长的统计
     */
    onEnterGame:function()
    {
        if(!this.countdownIng)
        {
            this.countdownIng = true;
        }
    },
    /**
     * @method 退出游戏界面   保存当前在线时长
     */
    onOutGame:function()
    {
        this.countdownIng = false;
        wb.GCUserDefault.setItem("hjCountdownTime", this.countdownTime);
        wb.GCUserDefault.save();
    }

};