/**
 * Created by skay on 2018/5/12.
 */
var wb = wb || {};

wb.BaseCfgItem = cc.Class.extend({

   ctor:function()
   {
      this.data = {};
   },
   str2Array:function(data)
   {
      var ret =[];
      if(data.length >2)
      {
         ret = JSON.parse(data);
      }
      return ret;
   },
   str2Int:function(data)
   {
      var ret = 0;
      if(data.length >0)
      {
         ret = parseInt(data);
      }
      return ret;
   },
   parseJsonData:function(data)
   {
      if(data && data.length>0) {
         var obj = this.str2Array(data);
         this.data = wb.uniqueObj( obj,{});
      }
   },
   obj2Str:function(){
      return JSON.stringify(this.data);
   },
   fixArrayLastItem:function(arr)
   {
      if(arr)
      {
         if(arr[arr.length-1] === "")
         {
            arr.splice(arr.length -1,1);
         }
      }
   }
});

wb.HjTaskItem = wb.BaseCfgItem.extend({
   data:{
      ID:0,
      type:0,        //1进入某游戏    2某游戏过关    3某游戏达到多少分    4莫游戏玩多少时间          100连续7天  101连续15天  102连续30天
      title:"",
      name:"",
      target:[],
      targetNum:[],
      bonus:[],
      bonusNum:[],
      targetMess:[],
      ptargetNum:[], //任务完成进度

   },
   parseData:function(data)
   {
      if(data && data.length>2)
      {
         this.data.ID = parseInt(data[0]);
         this.data.type = parseInt(data[1]);
         this.data.title = data[2];
         this.data.name = data[3];
         this.data.target = JSON.parse(data[4]);
         this.data.targetNum = JSON.parse(data[5]);
         this.data.bonus = JSON.parse(data[6]);
         this.data.bonusNum = JSON.parse(data[7]);
         this.data.targetMess = JSON.parse(data[8]);
         this.fixArrayLastItem(this.data.target);
         this.fixArrayLastItem(this.data.targetNum);
         this.fixArrayLastItem(this.data.bonus);
         this.fixArrayLastItem(this.data.bonusNum);
         this.fixArrayLastItem(this.data.targetMess);
         this.data.ptargetNum =[];
         for(var i=0;i<this.data.targetNum.length;i++)
         {
            this.data.ptargetNum.push(0);
         }
      }
   },
});

wb.HjTaskManager ={

   taskUsedIds:[],   //刷新出现过的任务id
   taskItems:[],     //当前任务列表
   orgtaskItems:[],  //原始任务列表
   lxTaskItems:{},   //连续任务列表
   currentItem:null, //当前任务
   completed:0,      //是否完成  0未完成  1完成
   getBounded:0,     //是否领取了奖励  0未领取  1 领取
   lxBoundDays:0, //领取了连续任务的天数
   times:0,     //游戏开始时间
   lx_days:0,  //连续天数
   lx_max_days:30,
   changed:0,  //是否是刷新的任务
   init:function(){ //如果是网络时间的话要先取到网络时间才行
      this.taskItems = [];
      this.orgtaskItems =[];
      this.taskUsedIds=[];
      this.currentItem=null;
      this.lx_days = 0;
      this.times = 0;
      this.completed = 0;
      this.getBounded = 0;
      this.lxTaskItems = {};
      this.lx_days = parseInt(wb.GCUserDefault.getItem("tasklxdays", 0));
      this.lxBoundDays = parseInt(wb.GCUserDefault.getItem("taskLxBoundDays", 0));
      if(!wb.HJCore.isSameDay())
      {
         if(wb.GCUserDefault.getItem("taskcompleted", 0) === 0)
         {
            this.lx_days = 0;    //中断一次连续任务
            this.lxBoundDays = 0;
         }
         if(this.lx_days >= this.lx_max_days)
         {
            this.lx_days = this.lx_days %  this.lx_max_days;
            this.lxBoundDays = 0;
         }
         wb.GCUserDefault.setItem("tasklxdays",  this.lx_days);
         wb.GCUserDefault.setItem("taskLxBoundDays", this.lxBoundDays);
         wb.GCUserDefault.setItem("taskgetBounded", 0);
         wb.GCUserDefault.setItem("taskcompleted", 0);
         wb.GCUserDefault.setItem("taskUsedIds", "");
         wb.GCUserDefault.setItem("currenttask", "");
         wb.GCUserDefault.save();
      }
      this.initDailyTask();
   },
   /**
    * @method 初始化任务信息
    */
   initDailyTask:function()
   {
      //先判断日期 隔天后数据清空
      var str_ids = wb.GCUserDefault.getItem("taskUsedIds", "");
      var c_taskStr = wb.GCUserDefault.getItem("currenttask", "");
      this.completed = parseInt(wb.GCUserDefault.getItem("taskcompleted", 0));
      this.getBounded = parseInt(wb.GCUserDefault.getItem("taskgetBounded", 0));
      if(c_taskStr)
      {
         this.currentItem = new wb.HjTaskItem();
         this.currentItem.parseJsonData(c_taskStr);
      }
      if(str_ids.length >0){
         this.taskUsedIds = JSON.parse(str_ids);
      }
      wb.CSVParse.parseConfig(wb.res.task_cfg_csv,function(data)
      {
         if(data && data.length > 1)
         {
            for(var i = 1 ;i < data.length;i++)
            {
               if(data[i].length >0)
               {
                  var item = new wb.HjTaskItem();
                  item.parseData(data[i]);
                  var itemEnable = true;
                  if(item.data === undefined || item.data.type === undefined)
                  {
                     item = null;
                     continue;
                  }
                  if(item.data.type >=100)
                  {
                     this.lxTaskItems[""+item.data.type ] = item;
                     itemEnable = false;
                  }else
                  {
                     if(this.currentItem && this.currentItem.data.ID === item.data.ID)
                     {
                        itemEnable = false;
                     }else
                     {
                        for(var j = 0;j <this.taskUsedIds.length;j++)
                        {
                           if(this.taskUsedIds[j] === item.ID)
                           {
                              itemEnable = false;
                              break;
                           }
                        }
                     }
                     this.orgtaskItems.push(item);
                     if(itemEnable)
                     {
                        this.taskItems.push(item);
                     }
                  }
               }
            }
            //刷新一个任务出来
            if(!this.currentItem)
            {
               this.getCurrentTask();
            }
         }
      }.bind(this));
   },
   /**
    * @method 获取当前任务
    * @param {bool} isChange 是否是切换任务
    */
   getCurrentTask:function(isChange)  //获取当前任务
   {
      if(this.taskItems.length >0 && (!this.currentItem || isChange) )
      {
         var index = parseInt(Math.random() * this.taskItems.length);
         this.currentItem = this.taskItems[index];
         this.taskUsedIds.push(this.currentItem.data.ID);
         this.taskItems.splice(index,1);
         var str_usedIds ="";
         for(var i =0;i<this.taskUsedIds.length;i++)
         {
            str_usedIds += (this.taskUsedIds[i] +",");
         }
         if(str_usedIds.length >0)
         {
            str_usedIds = str_usedIds.substring(0,str_usedIds.length -1);
         }
         str_usedIds = "["+str_usedIds+"]";
         this.completed = 0;

         wb.GCUserDefault.setItem("taskcompleted", 0);
         wb.GCUserDefault.setItem("taskUsedIds", str_usedIds);
         wb.GCUserDefault.setItem("currenttask", this.currentItem.obj2Str());
         wb.GCUserDefault.save();
      }
      return this.currentItem;
   },
   /**
    * @method 切换任务
    */
   changeTask:function()
   {
      if(this.completed) return false;
      return this.currentItem !== this.getCurrentTask(true);
   },
   /**
    * @method 是否可以切换任务
    */
   changeTaskEnable:function()
   {
      if(this.completed) return false;
      return this.taskItems.length > 0;
   },

   /*
    * @method 领取任务奖励
    * @return [bool]  可以领取 true     不可领取 false
    */
   getBounds:function()
   {
      if(this.getBoundsEnable())
      {
         wb.GCUserDefault.setItem("taskgetBounded", 1);
         wb.GCUserDefault.save();
         this.getBounded = 1;
         return true;
      }
      return false;
   },
   /*
    * @method 是否可以领取任务奖励
    * @return [int]     可以领取 1     已领取 0   未完成 -1
    */
   getBoundsEnable:function()
   {
      if(!this.completed) return -1;
      if(this.getBounded) return 0;
      return 1;
   },

   /*
    * @method 领取连续任务奖励
    * @param [int] id     100 7天奖励   101 14天奖励     102 30天奖励
    */
   getLxTaskBounds:function(id)
   {
      if(this.getLxTaskBoundsEnable(id))
      {
         this.lxBoundDays =this.lxTaskItems[id+""].data.targetNum[0];
         wb.GCUserDefault.setItem("taskLxBoundDays", this.lxBoundDays);
         wb.GCUserDefault.save();
      }
   },
   /*
    * @method 是否可以领取连续任务奖励
    * @param [int] id     100 7天奖励   101 14天奖励     102 30天奖励
    * @return [bool]  可以领取 true     不可领取 false
    */
   getLxTaskBoundsEnable:function(id)
   {
      if(this.lxBoundDays >= this.lx_days) return false;
      if(this.lxTaskItems && this.lxTaskItems[id+""] && this.lxTaskItems[id+""].data.targetNum[0] > this.lxBoundDays
                  && this.lx_days >= this.lxTaskItems[id+""].data.targetNum[0])
      {
         return true;
      }
      return false;
   },
   /*
    * @method   获取连续任务
    * @param [int] id     100 7天奖励   101 14天奖励     102 30天奖励
    * @return [obj]
    */
   getLxTaskItem:function(id)
   {
      if(this.lxTaskItems && this.lxTaskItems[id+""] )
      {
         return  this.lxTaskItems[id+""];
      }
      return null;
   },

   /**
    * @method 开始进入某游戏的游戏界面
    */
   startGame:function(game)
   {
     if(this.completed || !this.currentItem) return;
      this.times = 0;
      if(this.currentItem.data.type === 4)
      {
         var index = -1;
         for(var i = 0 ; i < this.currentItem.data.target.length ; i++ )
         {
            if(game === this.currentItem.data.target[i])
            {
               index = i;
            }
         }
         if(index !== -1)
         {
            this.times  = wb.getLocalTime();
         }
      }
   },
   /**
    * @method 退出某游戏游戏界面
    */
   endGame:function(game,flag,score)
   {
      if(this.completed || !this.currentItem) return;
      var index = -1;
      for(var i = 0 ; i < this.currentItem.data.target.length ; i++ )
      {
         if(game === this.currentItem.data.target[i])
         {
            index = i;
            break;
         }
      }
      if(index === -1 || this.currentItem.data.targetNum.length < index || this.currentItem.data.targetNum[index] <= 0) return;
      if(this.currentItem.data.type === 1 )  //过关
      {
         if(flag)
         {
            this.currentItem.data.ptargetNum[index] ++;
            if( this.currentItem.data.ptargetNum[index]  > this.currentItem.data.targetNum[index])
            {
               this.currentItem.data.ptargetNum[index] = this.currentItem.data.targetNum[index];
            }
         }
      }
      else if(this.currentItem.data.type === 2 )   //进入游戏
      {
         this.currentItem.data.ptargetNum[index] ++;
         if( this.currentItem.data.ptargetNum[index]  > this.currentItem.data.targetNum[index])
         {
            this.currentItem.data.ptargetNum[index] = this.currentItem.data.targetNum[index];
         }
      }
      else if(this.currentItem.data.type === 3 )      //分数/星级 达到
      {

         if(score !== undefined )
         {
            this.currentItem.data.ptargetNum[index] = score;
         }
      }else if(this.currentItem.data.type === 4)   //累积时长
      {
         if(this.times >0)
         {
            var subTime = wb.getLocalTime() - this.times ;
            if(subTime < 0)
            {
               subTime = 0;
            }
            this.currentItem.data.ptargetNum[index] += parseInt(subTime);
         }
         this.times = 0;
      }

      var temp = 1;
      for(var i = 0 ; i < this.currentItem.data.targetNum.length ; i++ )
      {
         if(this.currentItem.data.targetNum[i] > this.currentItem.data.ptargetNum[i])
         {
            temp = 0;
            break;
         }
      }
      this.completed = temp;
      if(this.completed)
      {
         this.lx_days +=1;
         this.taskItems = wb.copyArray(this.orgtaskItems);
         this.taskUsedIds.splice(0,this.taskUsedIds.length);
         this.taskUsedIds =[];
         var str_complete_dates = wb.GCUserDefault.getItem("complete_dates", "");
         str_complete_dates += ("`" + wb.getDate());
         wb.GCUserDefault.setItem("complete_dates",str_complete_dates);
      }
      wb.GCUserDefault.setItem("tasklxdays", this.lx_days);
      wb.GCUserDefault.setItem("taskcompleted", this.completed);
      wb.GCUserDefault.setItem("currenttask", this.currentItem.obj2Str());
      wb.GCUserDefault.save();
   },
   /**
    * @method 某游戏过关
    * @param {str} game  游戏名字 和配置里面对应
    * @param {int} score  得分/星级
    */
   successGame:function(game,score) //   分数可传可不传
   {
      if(this.completed || !this.currentItem) return;
      this.endGame(game,true,score);
   },
   /**
    * @method 某游戏失败
    * @param {str} game  游戏名字 和配置里面对应
    */
   failGame:function(game,score) //某游戏过关失败
   {
      if(this.completed || !this.currentItem) return;
      this.endGame(game,false,score);
   },
   /**
    * @method 所有完成任务的日期
    * @return {array}   格式 如 ["20180510","20180512"]
    */
   getCompletedDates:function()
   {
     var dates = wb.GCUserDefault.getItem("complete_dates", "").split('`');
      if(dates.length >0)
      {
         for(var i =0 ;i < dates.length;i++)
         {
            if(dates[i].length > 1)
            {
               dates[i] = parseInt(dates[i]);
            }
            else
            {
               dates.splice(i,1);
               i--;
            }
         }
      }
      return dates;
   }
};