/**
 * Created by skay on 2018/5/12.
 */
var wb = wb || {};

/**
 * @class  用户信息类
 */
wb.WBUserInfo = cc.Class.extend({
   data:{
      id:"",         //id           七位数字
      name:"",       //用户名
      sex:"",        //性别  0男 1女
      head:"",       //头像
      wxId:"",       //微信id
      wxname:"",     //微信名
      wxhead:"",     //微信头像
      phone_num:"",   //手机号
      lv:0,          //用户等级
      exp:0,         //经验值
      gold:0,        //充值金额
      diamond:0,      //钻石数量
      issign:0,       //是否签到
      create_date:"",   //创建日期
      createTime:0,     //创建时间 单位s
      login_time:0,     //登录时间 单位s
      lastloginTime:0,  //上次登录时间 单位s
      lastrechargeTime:0,  //上次充值时间 单位s
   },

   parseData:function(data)
   {
      if(data && data.length>2)
      {
      }
   },
   /**
    * @method 解析用户数据
    * @param {str} data  用户数据
    */
   parseJsonData:function(data)
   {
      if(data && data.length>0) {
         var obj = JSON.parse(data);
         this.data = wb.uniqueObj( obj,{});
         if(this.data.head=== undefined)
         {
            this.data.head = "";
         }
         if(this.data.wxId === undefined)
         {
            this.data.wxId = "";
         }
         if(this.data.phone_num === undefined)
         {
            this.data.phone_num = "";
         }
      }
   },
   /**
    * @method data 转成字符串
    * @return {str}
    */
   obj2Str:function(){
      return JSON.stringify(this.data);
   }
});

wb.WBUser = {
   changed:false,
   userInfo:null,
   init:function()
   {
      this.userInfo  = new wb.WBUserInfo();
      var items = wb.GCUserDefault.getStringForKey("wbUserInfo","");
      if(items.length > 1)
      {
         this.userInfo.parseJsonData(items);
      }
      if(this.userInfo.data && this.userInfo.data.id !== undefined && this.userInfo.data.id.length >1)
      {
         this.userInfo.data.lastloginTime = this.userInfo.data.login_time;
         this.userInfo.data.login_time = parseInt(new Date().getTime() /1000);
         this.saveInfo();
      }
      else
      {
         this.getNetInfo();
      }
      this.changed = wb.GCUserDefault.getBoolForKey("wbUserInfoChanged",false);
   },
   /**
    * @method 从服务器获取用户信息
    */
   getNetInfo:function()
   {
      var para = "id="+ this.userInfo.data.id +"&wxid="+ this.userInfo.data.wxId+"&wxname="+this.userInfo.data.wxname +
          "&wxhead=" +this.userInfo.data.wxhead +"&lsn="+ wb.SysConfig.getLsn() +"&imsi="+  wb.SysConfig.getImsi() +
          "&imei="+ wb.SysConfig.getImei() +"&mmid="+  wb.SysConfig.getMmid() +"&pid="+ wb.SysConfig.getPrjid()+"&appid="+ wb.SysConfig.getAppid();
      //cc.log("getNetInfo-----  para =  "+para);
      wb.HttpPost(GETUSERURL, para, function(sc, rc, response){
         if(response && response.data)
         {
            //cc.log("getNetInfo ----- "+ response.data);
            var t_info =  new wb.WBUserInfo();
            t_info.parseJsonData(response.data);
            t_info.data.lastrechargeTime = this.userInfo.data.lastrechargeTime;
            t_info.data.createTime = t_info.data.login_time;
            t_info.data.lastloginTime = t_info.data.login_time;
            this.userInfo.data = t_info.data;
            this.saveInfo();
         }
      }.bind(this));
   },
   /**
    * @method 用户充值
    * @param {int} fee_id 计费点id
    */
   recharge:function(fee_id)
   {
      var price = 300;   // 根据fee_id 获取价格
      var feeinfos = wb.PayManager.getDefaultFeeInfo();
      if(feeinfos)
      {
         price = feeinfos.getFeePriceByID(fee_id);
      }
      this.userInfo.data.gold += price;
      this.userInfo.data.lastrechargeTime = parseInt(new Date().getTime() /1000);
      this.saveInfo();
   },
   /**
    * @method 保存本地用户信息
    */
   saveInfo:function()
   {
      var str = this.userInfo.obj2Str();
      wb.GCUserDefault.setStringForKey("wbUserInfo",str);
      wb.GCUserDefault.save();
   },
   /**
    * @method 改变用户信息
    */
   changedInfo:function()
   {
      this.saveInfo();
      if(this.changed) return;
      this.changed = true;
      wb.GCUserDefault.setBoolForKey("wbUserInfoChanged",this.changed );
      wb.GCUserDefault.save();
   },
   /**
    * @method 提交服务器用户信息  只有用户信息发生过改变才会提交数据
    */
   submitInfo:function(forced)
   {
      if((this.changed||forced) && this.userInfo.data.id !=undefined && this.userInfo.data.id.length >0)
      {
         if(this.changed)
         {
            this.changed = false;
            wb.GCUserDefault.setBoolForKey("wbUserInfoChanged",this.changed );
            wb.GCUserDefault.save();
         }
         var para = "id="+ this.userInfo.data.id +"&wxid="+ this.userInfo.data.wxId+"&name="+this.userInfo.data.name +"&wxname="+this.userInfo.data.wxname +
             "&wxhead=" +this.userInfo.data.wxhead+"&lv="+ this.userInfo.data.lv +"&phone_num="+ this.userInfo.data.phone_num+"&gold="+ this.userInfo.data.gold+
             "&diamond="+ this.userInfo.data.diamond+"&sex="+ this.userInfo.data.sex+"&exp="+ this.userInfo.data.exp +"&tools="+  this.userInfo.data.tools
             +"&pid="+ wb.SysConfig.getPrjid()+"&appid="+ wb.SysConfig.getAppid();
         wb.HttpPost(UPDATEUSERURL, para, function(sc, rc, response){});
      }
   }
};

