/**
 * Created by skai1 on 2018/6/5.
 */
var wb = wb || {};
wb.jsRank =
{
    /**
     * @method    获取排行数据
     * @param {int} type 类型   1：每日排行 2：每月排行 3：全国排行
     * @param {function} callback 回调
     */
    getRank:function(type,callback)
    {
        var rankUrl = "http://zp.vimedia.cn:8998/LiuJiaoTopServlet?value=";
        var param="action=";
        param+= "getTop";
        param += "&pid=" +wb.SysConfig.getPrjid();
        param += "&chlid=" + wb.SysConfig.getMmid();
        param += "&lsn=" + wb.SysConfig.getLsn();
        param += "&appid=" + wb.SysConfig.getAppid();
        param += "&phoneModel=" + wb.SysConfig.getMoilemodel();
        param += "&version=" + wb.SysConfig.getAppVersion();
        param += "&grank=" + 0;
        param += "&topType=" + type;
        rankUrl += wb.base64.encode(param);
        wb.HttpFetch.xhrGet(rankUrl ,callback);
    },
    /**
     * @method    提交得分数据
     * @param {int} type 类型   1：每日排行 2：每月排行 3：全国排行
     * @param {int} score 得分
     * @param {int} level 关卡
     * @param {int} coins 钻石数
     * @param {int} total total
     */
    postScore:function (type,score,level,coins,total) {
        var url= "http://ad.vimedia.cn:8998/AlonePostServlet?value=";
        var para = "pid="+ wb.SysConfig.getPrjid()+"&lsn="+ wb.SysConfig.getLsn() +"&imsi="+  wb.SysConfig.getImsi() + "&child="+wb.SysConfig.getMmid()+
            "&appid="+ wb.SysConfig.getAppid()+"&imei="+ wb.SysConfig.getImei() +"&model="+  wb.SysConfig.getMoilemodel() +"&topType="+type+
            "&level="+(level ===undefined ?0:level)+ "&score="+(score === undefined?0:score)+"&coins="+(coins === undefined?0:coins)+"&total="+(total === undefined?0:total);
         url +=  wb.base64.encode(para);
        cc.log(url);
        wb.HttpFetch.xhrGet(url,null);
    },
    /**
     * @method    设置用户数据
     * @param {str} userid  用户id（openid）
     * @param {str} username 用户名
     * @param {int} hiscore 历史最高分
     * @param {int} hilevel 历史关数
     * @param {int} pkwins 全民PK冠军数
     * @param {str} avatar 头像URL
     * @param {int} coins  钻石数
     * @param {int} ticket 兑换券数
     */
    postUserInfo:function(userid,username,hiscore,hilevel,pkwins,avatar,coins,ticket)
    {
        var rankUrl = "http://zp.vimedia.cn:8998/LiuJiaoTopServlet?value=";
        var param="action=setUser";
        param += "&pid=" +wb.SysConfig.getPrjid();
        param += "&chlid=" + wb.SysConfig.getMmid();
        param += "&lsn=" + wb.SysConfig.getLsn();
        param += "&appid=" + wb.SysConfig.getAppid();
        param += "&phoneModel=" + wb.SysConfig.getMoilemodel();
        param += "&version=" + wb.SysConfig.getAppVersion();
        param += "&userid=" + (userid === undefined? "" :userid);
        param += "&username=" + (username === undefined? "" :username);
        param += "&hiscore=" + (hiscore === undefined?0:hiscore);
        param += "&hilevel=" + (hilevel === undefined?0:hilevel);
        param += "&pkwins=" + (pkwins === undefined?0:pkwins);
        param += "&avatar=" + (avatar === undefined? "" :avatar);
        param += "&coin=" + (coins === undefined?0:coins);
        param += "&ticket=" + (ticket === undefined?0:ticket);
        rankUrl += wb.base64.encode(param);
        cc.log(rankUrl);
        wb.HttpFetch.xhrGet(rankUrl,null);
    }
};