/**
 * Created by Zack on 2018/4/16.
 */
var wb = wb || {};

wb.ShopLayer = wb.BaseLayer.extend({
    data: null,
    _paySuccedFunc: null,
    ctor: function (data) {
        this.initData(data);
        this._super(this.data.jsonPath);
        this.initUI();
        return true;
    },
    onEnter: function () {
        this._super();
        this.popUI("uiPanel", 0);
    },
    onExit: function () {
        this._super();
        if (this.callId) wb.PayManager.removeOnPayFinishCallback(this.callId);
    },
    initData: function (data) {
        if (data) this.data = wb.uniqueObj(wb.shopData, data);
        else this.data = wb.shopData;

        this.callId = wb.PayManager.addOnPayFinishCallback(function (payParams) {
            cc.log("NoAdLayer pay~~~~~~~");
            this.payCallFunc(payParams);
        }.bind(this));
    },
    initUI: function () {

        var cData = this.data;

        wb.FW(this.rootNode, "btn_close", function () {
            this.closeLayer();
        }.bind(this));

        var listView = wb.FW(this.rootNode, "ListView");

        var item1 = wb.FW(this.rootNode, "item1");
        var item2 = wb.FW(this.rootNode, "item2");

        var itemP = item1.getPosition();
        var dP = wb.getNodeSubP(item1, item2);

        listView.removeAllChildren();

        var items = this.data.items;

        for (var i = 0; i < items.length; i++) {
            var item = item1.clone();
            item.setPosition(cc.p(itemP.x, itemP.y - i * dP.y));
            listView.addChild(item);

            wb.FW(item, "txt_zs").setString(items[i].diamond);
            wb.FW(item, "txt_price").setString(items[i].price);
            wb.FW(item, "btn_buy", function (btn) {
                cc.log("btn_buy " + btn.data);
                wb.PayManager.orderPay(btn.data);
            }.bind(this), items[i].id);
        }
    },
    payCallFunc: function (payParams) {
        cc.log("ShopLayer paySucced " + payParams.getPayResult());
        if (payParams.getPayResult() != wb.PAY_RESULT_SUCCESS) return;

        var id = payParams.getPayId();

        var obj = wb.getItemInArrayByFunc(this.data.items, function (item) {
            if (item.id == id) return true;
            return false;
        }.bind(this));

        if (!obj) return;

        wb.showRewardLayer({counts: obj.diamond, endP: this.data.diamondEndP});
        wb.showToast(wb.PAY_SUCCED_STR);
        wb.addCoin(obj.diamond);
    },
    // 自定义回调
    setPayCallFunc: function (func) {
        this._paySuccedFunc = func;
    }
});