/**
 * Created by zack on 2018/7/30.
 */
var wb = wb || {};

wb.PushAdBtn = ccui.Widget.extend({
    data: null,
    pushData: null,
    nSize: null,
    dataIndex: null,
    loopTime: null,
    ctor: function (dataIndex, pushData, nSize, loopTime) {
        this._super();
        if (!this.check(pushData)) return true;

        this.initData(dataIndex, pushData, nSize);
        this.initUI();
        this.initLoop(loopTime);

    },
    check: function (pushData) {
        if (!pushData || pushData.length <= 0) {
            this.setVisible(false);
            return false;
        }
        return true;
    },
    initLoop: function (loopTime) {
        if (!loopTime || loopTime <= 0) return;
        this.schedule(function () {
            this.loopNext();
        }.bind(this), loopTime, "loopTimeCall");
    },
    initData: function (dataIndex, pushData, nSize) {
        this.data = pushData[dataIndex];
        if (!this.data) return;
        this.nSize = nSize;
        this.dataIndex = dataIndex;
        this.pushData = pushData;
        this.setData(this.data);

        this.addClickEventListener(this.onClick);
        this.setTouchEnabled(true);
    },
    setData: function (data) {
        if (!data) return;
        this.data = data;

        wb.wxTool.loadImage(this.data.icon, function (texture2d) {
            this.createBtnSp(texture2d);
        }.bind(this));
    },
    createBtnSp: function (texture2d) {

        var bgSpSize = cc.size(101, 101);
        var isFirst = false;
        if (!this.clippingNode) {
            isFirst = true;
            var stencil = new cc.Sprite(wb.wxRes.pushFrame);
            stencil.setContentSize(this.nSize);
            stencil.setScaleX(this.nSize.width / bgSpSize.width);
            stencil.setScaleY(this.nSize.height / bgSpSize.height);
            stencil.setAnchorPoint(cc.p(0, 0));


            var clippingNode = new cc.ClippingNode();
            clippingNode.setInverted(false);
            //clippingNode.setAlphaThreshold(0);
            this.addChild(clippingNode, 1);
            clippingNode.setStencil(stencil);
            this.clippingNode = clippingNode;

            this.bgSp = new cc.Sprite(wb.wxRes.pushFrame);
            this.bgSp.setAnchorPoint(cc.p(0.5, 0.5));
            this.addChild(this.bgSp, 0);
        }


        var sp = new cc.Sprite(texture2d);
        //this.addChild(sp, 1);
        this.clippingNode.addChild(sp);

        this.setContentSize(sp.getContentSize());
        sp.setPosition(wb.getNodeCenterP(this));
        this.bgSp.setPosition(wb.getNodeCenterP(this));

        var spSize = sp.getContentSize();
        this.setContentSize(this.nSize);
        var nodeCP = wb.getNodeCenterP(this);
        // sp.setPosition(wb.getNodeCenterP(this));
        var scaleX = this.nSize.width / spSize.width;
        var scaleY = this.nSize.height / spSize.height;
        sp.setScaleX(scaleX);
        sp.setScaleY(scaleY);


        this.bgSp.setPosition(wb.getNodeCenterP(this));
        this.bgSp.setScaleX(this.nSize.width / bgSpSize.width + 0.05);
        this.bgSp.setScaleY(this.nSize.height / bgSpSize.height + 0.05);

        if (isFirst) {
            sp.setPosition(nodeCP);
        } else {
            sp.setPosition(cc.p(nodeCP.x + this.nSize.width, nodeCP.y));
            var seq = cc.sequence(cc.moveTo(0.4, nodeCP), cc.callFunc(function () {
                if (this.btnSp) this.btnSp.removeFromParent();
                this.btnSp = sp;
            }.bind(this)));
            sp.runAction(seq);
        }
    },
    initUI: function () {
    },
    onClick: function () {
        cc.log("onClick~~~~~");
        var openType = this.data.open;
        // var tjKey = "ad_" + openType;

        if (!wb.wx.checkSupportMiniprogram()) openType = "image";

        if (openType == "image") {
            wb.wx.previewImage({
                urls: [this.data.pushImage]
            })
        } else if (openType == "url") {

        } else if (openType == "miniprogram") {
            var tjKey = "ad_" + openType;
            wb.wx.navigateToMiniProgram({
                appId: this.data.pushAppID,
                path: this.data.openPath,
                extraData: {
                    vigame_from: "miniprogram"
                },
                success: function (res) {
                    wb.DataTJManager.event2(tjKey, "open_susecc_" + this.data.openPath);
                }
            });
        }
        wb.DataTJManager.event2(tjKey, "click");
        if (this.clickFunc) this.clickFunc(this);
        if (this.isLoop) this.loopNext();
    },
    // 监听回调
    setClickFunc: function (func) {
        this.clickFunc = func;
    },
    // 设置点击后为下一个
    setIsLoop: function (flag) {
        this.isLoop = flag;
    },
    // 循环
    loopNext: function () {
        this.dataIndex++;
        if (this.dataIndex >= this.pushData.length) this.dataIndex = 0;
        this.data = this.pushData[this.dataIndex];
        this.setData(this.data);
    }
});

// 默认互推按钮数据来自 iconList
wb.createPushAdBtn = function (index, data, size, loopTime) {
    if (!wb.wxData.pushData) return null;
    var dataIndex = index ? index : 0;
    var pushData = data ? data : wb.wxData.pushData.iconList;
    var loopTime = loopTime ? loopTime : 15;  // 循环时间
    var size = size ? size : cc.size(90, 90);

    //if ((!pushData) || pushData.length <= 0) return null;
    return new wb.PushAdBtn(dataIndex, pushData, size, loopTime);
};

//  默认互推banner数据来自 bannerList
wb.createPushBanner = function (index, data, size) {
    if (!wb.wxData.pushData) return null;
    var dataIndex = index ? index : 0;
    var pushData = data ? data : wb.wxData.pushData.bannerList;

    if (pushData.open == "banner") {
        wb.ADManager.openAd("banner");
        return null;
    }

    // if ((!pushData) || pushData.length <= 0) return null;
    var banner = new wb.PushAdBtn(dataIndex, pushData, size);
    var bannerSize = banner.getContentSize();
    // 默认在底端
    banner.setPosition(cc.p(bannerSize.width / 2, 0));
    return banner;
};
