/**
 * Created by zack on 2018/7/30.
 */
var wb = wb || {};

wb.PushAdLayer = cc.Layer.extend({
    data: null,
    enableIndex: [], // 可用下标
    bindLayer: null,
    ctor: function (pData, layer, size) {
        this._super();
        wb.PushAdLayerSingle = this;
        if (!this.check(layer)) return true;
        this.initData(pData, layer);
        this.initUI(pData, layer, size);
    },
    check: function (layer) {
        var bottomList = wb.wxData.pushData.bottomList;
        if (!bottomList || bottomList.length <= 0) {
            this.setVisible(false);
            layer.setVisible(false);
            return false;
        }
        return true;
    },
    initData: function (pData, layer) {
        this.enableIndex = [];
        this.bindLayer = layer;
    },
    initUI: function (pData, layer, size) {
        var bottomList = wb.wxData.pushData.bottomList;
        for (var i = 0; i < pData.length; i++) {
            if (i >= bottomList.length) {
                break
            }
            var adBtn = wb.createPushAdBtn(i, bottomList, size, -1);
            adBtn.setPosition(pData[i]);
            layer.addChild(adBtn, 1);
            adBtn.setClickFunc(this.clickFun);
            adBtn.dataIndex = i;
        }
        for (var i = pData.length; i < bottomList.length; i++) {
            this.enableIndex.push(i);
        }
    },
    clickFun: function (btn) {
        var self = wb.PushAdLayerSingle;
        cc.log("PushAdLayer clickFun");
        cc.log(self.enableIndex);
        var bottomList = wb.wxData.pushData.bottomList;
        var index = self.enableIndex.shift();
        var data = bottomList[index];
        btn.setData(data);
        self.enableIndex.push(btn.dataIndex);
        btn.dataIndex = index;
    }
});

// 根据坐标创建
wb.createPushAdLayerByData = function (data, layer, size) {
    return new wb.PushAdLayer(data, layer, size);
};

// 自带底图的互推
wb.createPushAdLayer = function (num, btnDw) {
    var dw = btnDw ? btnDw : 20;  // 间隔
    var num = num ? num : 4;      // 数量

    var btnSize = cc.size(90, 90);
    var bg = new cc.Sprite(wb.wxRes.wxPushBg);
    var bgSize = cc.size(455, 155);

    var bgCenterP = cc.p(bgSize.width / 2, bgSize.height / 2);
    var beganP = cc.p(bgCenterP.x - (num * btnSize.width + (num - 1) * dw) / 2 + btnSize.width / 2, bgCenterP.y - 15);
    var pList = [];
    for (var i = 0; i < 4; i++) {
        var p = cc.p(beganP.x + i * (dw + btnSize.width), beganP.y);
        pList.push(p);
    }

    for (var i = 0; i < pList.length; i++) {
        var frameSp = new cc.Sprite(wb.wxRes.pushFrame);
        frameSp.setPosition(pList[i]);
        bg.addChild(frameSp);
    }

    wb.createPushAdLayerByData(pList, bg, btnSize);
    return bg;
};
