/**
 * Created by Zack on 2018/1/9.
 */

var wb = wb || {};
wb.ADManager.bannerSingle = null;
wb.ADManager.videoSingle = null;

wb.ADManager.isVideoEnable = false;
wb.ADManager.videoAdCallFunc = null;  // 视频回调
wb.ADManager.videoADS = ["video", "level_fail_mfzs", "skin", "home_mfzs", "double_fail_mfzs"];

wb.ADManager.init = function () {
    wb.ADManager.createVideo();
};

wb.ADManager.isBannerAD = function (str) {
    if (str == "banner") return true;
    return false;
};

wb.ADManager.isVideoAD = function (str) {
    var videos = wb.ADManager.videoADS;
    for (var i = 0; i < videos.length; i++) {
        if (str == videos[i]) return true;
    }
    return false;
};

wb.ADManager.hideBanner = function () {
    if (!wb.ADManager.bannerSingle) return;
    wb.ADManager.bannerSingle.hide();
};

wb.ADManager.showBanner = function () {
    if (!wb.ADManager.bannerSingle) return;
    wb.ADManager.bannerSingle.show();
};

wb.ADManager.createBannerAD = function () {
    if (wb.wxConfig.bannerADid.length <= 0) return;
    wb.ADManager.closeAd("banner");
    var size = cc.view.getFrameSize();
    var bannerAd = wb.wx.createBannerAd({
        adUnitId: wb.wxConfig.bannerADid,
        style: {
            left: 0,
            top: size.height - 350,
            width: size.width,
            height: 60
        }
    });
    if (bannerAd) {
        wb.ADManager.bannerSingle = bannerAd;
        bannerAd.onResize(function (res) {
            cc.log(res);
            if (wb.ADManager.bannerSingle.style) wb.ADManager.bannerSingle.style.top = size.height - res.height;
        }.bind(this));
        bannerAd.show();
    }
};
wb.ADManager.createVideo = function () {
    if (wb.ADManager.videoSingle) return;
    if (wb.wxConfig.videoADid.length <= 0) return;
    cc.log("wb.ADManager.createVideo~");
    var videoAd = wb.wx.createRewardedVideoAd({
        adUnitId: wb.wxConfig.videoADid
    });
    wb.ADManager.videoSingle = videoAd;
    if (videoAd) {
        videoAd.onLoad(function () {
            cc.log("videoAd.onLoad");
            wb.ADManager.isVideoEnable = true;
        });

        videoAd.onError(function () {
            cc.log("videoAd.onError");
            wb.ADManager.isVideoEnable = false;
            wb.ADManager.videoSingle.load();
        });

        // wb.ADManager.videoAdCallFunc = null;
        videoAd.onClose(function (res) {
            wb.ADManager.showBanner();
            cc.audioEngine.resumeMusic();

            if (!wb.ADManager.videoAdCallFunc) return;
            if (!res) wb.ADManager.videoAdCallFunc({isEnded: true}, 0);
            else {
                var result = -1;
                if (res.isEnded) result = 0;
                wb.ADManager.videoAdCallFunc(res, result);
            }
        });

    }
};

wb.ADManager.closeAd = function (str) {
    if (wb.ADManager.isBannerAD(str)) {
        if (wb.ADManager.bannerSingle) {
            wb.ADManager.bannerSingle.hide();
            wb.ADManager.bannerSingle.destroy();
            wb.ADManager.bannerSingle = null;
        }
    } else if (wb.ADManager.isVideoAD(str)) {
    }
};


wb.ADManager.openAd = function (str) {
    if (!wb.ADManager.isAdReady(str)) return false;

    if (wb.ADManager.isBannerAD(str)) {
        wb.ADManager.createBannerAD(str);
    } else if (wb.ADManager.isVideoAD(str)) {
        cc.audioEngine.pauseMusic();
        wb.ADManager.createVideo();
        wb.ADManager.hideBanner();
        wb.ADManager.videoAdCallFunc = null;
        wb.ADManager.videoSingle.show();
    }
};

wb.ADManager.openAdC = function (str, func) {
    if (!wb.ADManager.isAdReady(str)) return false;

    if (wb.ADManager.isBannerAD(str)) {
        wb.ADManager.createBannerAD(str);
        if (func) func(null, 0);
    } else if (wb.ADManager.isVideoAD(str)) {
        cc.audioEngine.pauseMusic();
        wb.ADManager.createVideo();
        wb.ADManager.hideBanner();
        wb.ADManager.videoAdCallFunc = func;
        wb.ADManager.videoSingle.show();
    }

};


wb.ADManager.isAdReady = function (position, type) {
    if (wb.ADManager.isBannerAD(position)) {
        return true;
    } else if (wb.ADManager.isVideoAD(position)) {
        return wb.ADManager.isVideoEnable;
    }
    return true;
};

wb.ADManager.isAdEnable = function (position) {
    return true;
};